package CruiserHard.Complication;

import java.awt.*;

public class DrawBlockTriangle implements IDrawBlock {
    private Block blockCount;

    @Override
    public void SetBlockCount(int num) {
        switch (num) {
            case 1:
                blockCount = Block.One;
                break;
            case 2:
                blockCount = Block.Two;
                break;
            default:
                blockCount = Block.Three;
        }
    }

    @Override
    public Block GetBlockCount() {
        return blockCount;
    }

    @Override
    public void DrawBlocks(int _startPosX, int _startPosY, Graphics g2d) {
        switch (blockCount) {
            case One:
                break;

            case Two:
                DrawFirstDopTriangle(_startPosX, _startPosY, g2d);
                break;

            case Three:
                DrawSecondDopTriangle(_startPosX, _startPosY, g2d);
                break;
        }
    }

    public void DrawFirstDopTriangle(int _startPosX, int _startPosY, Graphics g2d) {
        Polygon elementsSec = new Polygon();
        elementsSec.addPoint(_startPosX + 55, _startPosY + 25);
        elementsSec.addPoint(_startPosX + 65, _startPosY + 30);
        elementsSec.addPoint(_startPosX + 55, _startPosY + 35);
        g2d.setColor(Color.WHITE);
        g2d.fillPolygon(elementsSec);
    }

    public void DrawSecondDopTriangle(int _startPosX, int _startPosY, Graphics g2d) {
        DrawFirstDopTriangle(_startPosX, _startPosY, g2d);
        Polygon elementsThree = new Polygon();
        elementsThree.addPoint(_startPosX + 75, _startPosY + 15);
        elementsThree.addPoint(_startPosX + 85, _startPosY + 30);
        elementsThree.addPoint(_startPosX + 75, _startPosY + 45);
        g2d.setColor(Color.WHITE);
        g2d.fillPolygon(elementsThree);
    }
}