package CruiserHard.Drawing;
import java.awt.*;
import java.util.Random;

import CruiserHard.Complication.DrawBlock;
import CruiserHard.Complication.DrawBlockOval;
import CruiserHard.Complication.DrawBlockTriangle;
import CruiserHard.Complication.IDrawBlock;

import CruiserHard.Entity.*;

public class DrawingHelipadCruiser extends DrawingCruiser {
    private IDrawBlock drawingBlocks;
    public DrawingHelipadCruiser(int speed, float weight, Color bodyColor, Color
            elementsColor, boolean rocketMines, boolean helipad, int width, int height, int blockCount)
    {
        super(speed, weight, bodyColor, width, height, blockCount);
        if (cruiser != null)
        {
            cruiser = new EntityHelipadCruiser(speed, weight, bodyColor,
                    elementsColor, rocketMines, helipad);
        }
        Random rand = new Random();
        drawingBlocks = switch (rand.nextInt(3)) {
            case 0 -> new DrawBlock();
            case 1 -> new DrawBlockOval();
            case 2 -> new DrawBlockTriangle();
            default -> new DrawBlock();
        };

        drawingBlocks.SetBlockCount(blockCount);
    }
    @Override
    public void DrawTransport(Graphics g) {
        if (!(cruiser instanceof EntityHelipadCruiser helipadCrusier)) {
            return;
        }
        super.DrawTransport(g);
        drawingBlocks.DrawBlocks(_startPosX, _startPosY,g);
        if (helipadCrusier.GetRocketMines()){
            g.setColor(Color.green);
            g.fillRect(_startPosX + 15, _startPosY + 10, 10, 15);
            g.fillRect(_startPosX + 30, _startPosY + 10, 10, 15);
        }
        if (helipadCrusier.GetHelipad())
        {
            // верт площадка
            g.setColor(Color.ORANGE);
            g.fillOval(_startPosX + 15, _startPosY + 25, 25, 25);
        }
    }
}
