package CruiserHard;
import javax.swing.*;
import java.awt.*;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.*;
import CruiserHard.Drawing.*;
import CruiserHard.Direction.*;
import CruiserHard.MovementStrategy.*;

public class FormCruiser{
    private DrawingCruiser _drawingCruiser;
    private AbstractStrategy _abstractStrategy;
    Canvas canv;
    public void Draw(){
        canv.repaint();
    }
    public FormCruiser(){
        JFrame frame = new JFrame("RoadTrain");
        JButton buttonCreateCruiser = new JButton("Крейсер");
        buttonCreateCruiser.setFocusPainted(false);
        buttonCreateCruiser.setContentAreaFilled(false);
        JButton buttonCreateHelipadCruiser = new JButton("СуперКрейсер");
        buttonCreateHelipadCruiser.setFocusPainted(false);
        buttonCreateHelipadCruiser.setContentAreaFilled(false);
        String[] items = {
                "ToCenter",
                "ToBorder"
        };
        JComboBox comboBoxStrategy = new JComboBox(items);
        JButton buttonStep = new JButton("Шаг");
        buttonStep.setFocusPainted(false);
        buttonStep.setContentAreaFilled(false);
        JButton buttonUp = new JButton();
        buttonUp.setFocusPainted(false);
        buttonUp.setContentAreaFilled(false);
        buttonUp.setName("up");
        buttonUp.setIcon(new ImageIcon(((new ImageIcon("src/CruiserHard/Images/totop.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonDown = new JButton();
        buttonDown.setFocusPainted(false);
        buttonDown.setContentAreaFilled(false);
        buttonDown.setName("down");
        buttonDown.setIcon(new ImageIcon(((new ImageIcon("src/CruiserHard/Images/todown.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonLeft = new JButton();
        buttonLeft.setFocusPainted(false);
        buttonLeft.setContentAreaFilled(false);
        buttonLeft.setName("left");
        buttonLeft.setIcon(new ImageIcon(((new ImageIcon("src/CruiserHard/Images/toleft.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonRight = new JButton();
        buttonRight.setFocusPainted(false);
        buttonRight.setContentAreaFilled(false);
        buttonRight.setName("right");
        buttonRight.setIcon(new ImageIcon(((new ImageIcon("src/CruiserHard/Images/toright.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        buttonCreateCruiser.addActionListener(
                e -> {
                    Random random = new Random();
                    _drawingCruiser = new DrawingCruiser(random.nextInt(200) + 100,
                            random.nextInt(2000) + 1000,
                            new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                            this.canv.getWidth(), this.canv.getHeight(), random.nextInt(3-1+1)+1);
                    _drawingCruiser.SetPosition(random.nextInt(100-30+1)+30, //начальные и конечные значения для рандома
                            random.nextInt(90-20+1)+20 //начальные и конечные значения для рандома
                            ,this.canv.getWidth(), this.canv.getHeight());
                    canv._drawingCruiser = _drawingCruiser;
                    Draw();
                }
        );
        buttonCreateHelipadCruiser.addActionListener(
                e -> {
                    Random random = new Random();
                    _drawingCruiser = new DrawingHelipadCruiser(random.nextInt(100) + 50,
                            random.nextInt(1000) + 500,
                            new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                            new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                            random.nextBoolean(), random.nextBoolean(),
                            this.canv.getWidth(), this.canv.getHeight(), random.nextInt(3-1+1)+1);
                    _drawingCruiser.SetPosition(random.nextInt(100-30+1)+30, //начальные и конечные значения для рандома
                            random.nextInt(90-20+1)+20 //начальные и конечные значения для рандома
                            ,this.canv.getWidth(), this.canv.getHeight());
                    canv._drawingCruiser = _drawingCruiser;
                    Draw();
                }
        );
        ActionListener actionListener = e -> {
            if (_drawingCruiser == null){
                return;
            }
            switch ((((JButton)(e.getSource())).getName())){
                case "up":
                    _drawingCruiser.MoveTransport(Direction.Up);
                    break;
                case "down":
                    _drawingCruiser.MoveTransport(Direction.Down);
                    break;
                case "left":
                    _drawingCruiser.MoveTransport(Direction.Left);
                    break;
                case "right":
                    _drawingCruiser.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        };
        buttonUp.addActionListener(actionListener);
        buttonDown.addActionListener(actionListener);
        buttonLeft.addActionListener(actionListener);
        buttonRight.addActionListener(actionListener);
        buttonStep.addActionListener(e -> {
            if (_drawingCruiser == null) {
                return;
            }
            if (comboBoxStrategy.isEnabled()) {
                _abstractStrategy = switch (comboBoxStrategy.getSelectedIndex()) {
                    case 0 -> new MoveToCenter();
                    case 1 -> new MoveToBorder();
                    default -> null;
                };
                if (_abstractStrategy == null)
                {
                    return;
                }
                _abstractStrategy.SetData(new DrawingObjectCruiser(_drawingCruiser), this.canv.getWidth(), this.canv.getHeight());
            }
            if (_abstractStrategy == null)
            {
                return;
            }
            comboBoxStrategy.setEnabled(false);
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish)
            {
                comboBoxStrategy.setEnabled(true);
                _abstractStrategy = null;
            }
        });
        frame.setSize(910, 500);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLayout(null);
        canv = new Canvas();
        canv.setBounds(0, 0, 895, 500 - 40); // 40 - const, высота панели сверху
        buttonCreateCruiser.setBounds(20, 420, 100, 40);
        buttonCreateHelipadCruiser.setBounds(140, 420, 100, 40);
        buttonUp.setBounds(800, 380, 40, 40);
        buttonDown.setBounds(800, 420, 40, 40);
        buttonLeft.setBounds(760, 420, 40, 40);
        buttonRight.setBounds(840, 420, 40, 40);
        comboBoxStrategy.setBounds(800,10,100,50);
        buttonStep.setBounds(800,80,100,40);
        frame.add(canv);
        frame.add(buttonCreateCruiser);
        frame.add(buttonCreateHelipadCruiser);
        frame.add(buttonUp);
        frame.add(buttonDown);
        frame.add(buttonLeft);
        frame.add(buttonRight);
        frame.add(comboBoxStrategy);
        frame.add(buttonStep);
        frame.setVisible(true);
    }
    class Canvas extends JComponent{
        public DrawingCruiser _drawingCruiser;
        public Canvas(){}

        public void paintComponent(Graphics g){
            if (_drawingCruiser == null){
                return;
            }
            super.paintComponents(g);
            Graphics2D g2d = (Graphics2D)g;
            _drawingCruiser.DrawTransport(g2d);
            super.repaint();
        }
    }
}