package CruiserHard.MovementStrategy;
import CruiserHard.Direction.*;
import CruiserHard.Drawing.*;

public class DrawingObjectCruiser implements IMoveableObject{
    private DrawingCruiser _drawingCruiser = null;
    public DrawingObjectCruiser (DrawingCruiser drawingCruiser)
    {
        _drawingCruiser = drawingCruiser;
    }
    @Override
    public ObjectParameters GetObjectPosition() {
        if (_drawingCruiser == null || _drawingCruiser.cruiser == null) {
            return null;
        }
        return new ObjectParameters(_drawingCruiser.GetStartX(), _drawingCruiser.GetStartY(),
                _drawingCruiser.GetWidth(), _drawingCruiser.GetHeight());
    }

    @Override
    public int GetStep() {
        if (_drawingCruiser != null && _drawingCruiser.cruiser!=null)
            return (int)(_drawingCruiser.cruiser.GetStep());
        return 0;
    }

    @Override
    public boolean CheckCanMove(Direction direction) {
        if (_drawingCruiser != null)
            return _drawingCruiser.CanMove(direction);
        return false;
    }

    @Override
    public void MoveObject(Direction direction) {
        if (_drawingCruiser != null)
            _drawingCruiser.MoveTransport(direction);
    }
}
