package CruiserHard.MovementStrategy;
public class MoveToBorder extends AbstractStrategy{
    @Override
    protected boolean isTargetDestination() {
        var objParams = GetObjectParameters();
        if (objParams == null) {
            return false;
        }
        return objParams.RightBorder() <= GetFieldWidth() &&
                objParams.RightBorder() + GetStep() >= GetFieldWidth() &&
                objParams.DownBorder() <= GetFieldHeight() &&
                objParams.DownBorder() + GetStep() >= GetFieldHeight();
    }

    @Override
    protected void MoveToTarget() {
        var objParams = GetObjectParameters();
        if (objParams == null) {
            return;
        }
        var diffX = objParams.ObjectMiddleHorizontal() - GetFieldWidth();
        if (Math.abs(diffX) > GetStep()) {
            if (diffX < 0) {
                MoveRight();
            }
        }
        var diffY = objParams.ObjectMiddleVertical() - GetFieldHeight();
        if (Math.abs(diffY) > GetStep()) {
            if (diffY < 0) {
                MoveDown();
            }
        }
    }
}
